// This is a generated file, modify: generate/templates/class_content.cc.
#include <nan.h>
#include <string.h>
#include <chrono>
#include <thread>

extern "C" {
#include <git2.h>
}

#include "../include/functions/copy.h"
#include "../include/macros.h"
#include "../include/cvar_map.h"


#include <iostream>

using namespace std;
using namespace v8;
using namespace node;

GitCvarMap::GitCvarMap(git_cvar_map *raw, bool selfFreeing)
{
  this->raw = raw;
  this->selfFreeing = selfFreeing;
}

GitCvarMap::~GitCvarMap()
{

  // this will cause an error if you have a non-self-freeing object that also needs
  // to save values. Since the object that will eventually free the object has no
  // way of knowing to free these values.

}

void GitCvarMap::InitializeComponent(Handle<v8::Object> target)
{
  NanScope();

  Local<FunctionTemplate> tpl = NanNew<FunctionTemplate>(JSNewFunction);

  tpl->InstanceTemplate()->SetInternalFieldCount(1);
  tpl->SetClassName(NanNew<String>("CvarMap"));

  NODE_SET_PROTOTYPE_METHOD(tpl, "cvarType", CvarType);
  NODE_SET_PROTOTYPE_METHOD(tpl, "strMatch", StrMatch);
  NODE_SET_PROTOTYPE_METHOD(tpl, "mapValue", MapValue);

  Local<Function> _constructor_template = tpl->GetFunction();
  NanAssignPersistent(constructor_template, _constructor_template);
  target->Set(NanNew<String>("CvarMap"), _constructor_template);
}

NAN_METHOD(GitCvarMap::JSNewFunction)
{
  NanScope();

  if (args.Length() == 0 || !args[0]->IsExternal()) {
    return NanThrowError("A new GitCvarMap cannot be instantiated.");
  }

  GitCvarMap* object = new GitCvarMap(static_cast<git_cvar_map *>(Handle<External>::Cast(args[0])->Value()), args[1]->BooleanValue());
  object->Wrap(args.This());

  NanReturnValue(args.This());
}

Handle<v8::Value> GitCvarMap::New(void *raw, bool selfFreeing)
{
  NanEscapableScope();
  Handle<v8::Value> argv[2] = { NanNew<External>((void *)raw), NanNew<Boolean>(selfFreeing) };
  return NanEscapeScope(NanNew<Function>(GitCvarMap::constructor_template)->NewInstance(2, argv));
}

git_cvar_map *GitCvarMap::GetValue()
{
  return this->raw;
}

git_cvar_map **GitCvarMap::GetRefValue()
{
  return this->raw == NULL ? NULL : &this->raw;
}

void GitCvarMap::ClearValue()
{
  this->raw = NULL;
}

NAN_METHOD(GitCvarMap::CvarType)
{
  NanScope();
  Handle<v8::Value> to;

  git_cvar_t
  cvar_type =
    ObjectWrap::Unwrap<GitCvarMap>(args.This())->GetValue()->cvar_type;
// start convert_to_v8 block
  to = NanNew<Number>(cvar_type);
  // end convert_to_v8 block
  NanReturnValue(to);
}
NAN_METHOD(GitCvarMap::StrMatch)
{
  NanScope();
  Handle<v8::Value> to;

  const char *
  str_match =
    ObjectWrap::Unwrap<GitCvarMap>(args.This())->GetValue()->str_match;
// start convert_to_v8 block
  if (str_match) {
    to = NanNew<String>(str_match);
  } else {
    to = NanNull();
  }

  // end convert_to_v8 block
  NanReturnValue(to);
}
NAN_METHOD(GitCvarMap::MapValue)
{
  NanScope();
  Handle<v8::Value> to;

  int
  map_value =
    ObjectWrap::Unwrap<GitCvarMap>(args.This())->GetValue()->map_value;
// start convert_to_v8 block
  to = NanNew<Number>(map_value);
  // end convert_to_v8 block
  NanReturnValue(to);
}
Persistent<Function> GitCvarMap::constructor_template;
