// This is a generated file, modify: generate/templates/class_content.cc.
#include <nan.h>
#include <string.h>
#include <chrono>
#include <thread>

extern "C" {
#include <git2.h>
}

#include "../include/functions/copy.h"
#include "../include/macros.h"
#include "../include/status_entry.h"

#include "../include/diff_delta.h"

#include <iostream>

using namespace std;
using namespace v8;
using namespace node;

GitStatusEntry::GitStatusEntry(git_status_entry *raw, bool selfFreeing)
{
  this->raw = raw;
  this->selfFreeing = selfFreeing;
}

GitStatusEntry::~GitStatusEntry()
{

  // this will cause an error if you have a non-self-freeing object that also needs
  // to save values. Since the object that will eventually free the object has no
  // way of knowing to free these values.

}

void GitStatusEntry::InitializeComponent(Handle<v8::Object> target)
{
  NanScope();

  Local<FunctionTemplate> tpl = NanNew<FunctionTemplate>(JSNewFunction);

  tpl->InstanceTemplate()->SetInternalFieldCount(1);
  tpl->SetClassName(NanNew<String>("StatusEntry"));

  NODE_SET_PROTOTYPE_METHOD(tpl, "status", Status);
  NODE_SET_PROTOTYPE_METHOD(tpl, "headToIndex", HeadToIndex);
  NODE_SET_PROTOTYPE_METHOD(tpl, "indexToWorkdir", IndexToWorkdir);

  Local<Function> _constructor_template = tpl->GetFunction();
  NanAssignPersistent(constructor_template, _constructor_template);
  target->Set(NanNew<String>("StatusEntry"), _constructor_template);
}

NAN_METHOD(GitStatusEntry::JSNewFunction)
{
  NanScope();

  if (args.Length() == 0 || !args[0]->IsExternal()) {
    return NanThrowError("A new GitStatusEntry cannot be instantiated.");
  }

  GitStatusEntry* object = new GitStatusEntry(static_cast<git_status_entry *>(Handle<External>::Cast(args[0])->Value()), args[1]->BooleanValue());
  object->Wrap(args.This());

  NanReturnValue(args.This());
}

Handle<v8::Value> GitStatusEntry::New(void *raw, bool selfFreeing)
{
  NanEscapableScope();
  Handle<v8::Value> argv[2] = { NanNew<External>((void *)raw), NanNew<Boolean>(selfFreeing) };
  return NanEscapeScope(NanNew<Function>(GitStatusEntry::constructor_template)->NewInstance(2, argv));
}

git_status_entry *GitStatusEntry::GetValue()
{
  return this->raw;
}

git_status_entry **GitStatusEntry::GetRefValue()
{
  return this->raw == NULL ? NULL : &this->raw;
}

void GitStatusEntry::ClearValue()
{
  this->raw = NULL;
}

NAN_METHOD(GitStatusEntry::Status)
{
  NanScope();
  Handle<v8::Value> to;

  git_status_t
  status =
    ObjectWrap::Unwrap<GitStatusEntry>(args.This())->GetValue()->status;
// start convert_to_v8 block
  to = NanNew<Number>(status);
  // end convert_to_v8 block
  NanReturnValue(to);
}
NAN_METHOD(GitStatusEntry::HeadToIndex)
{
  NanScope();
  Handle<v8::Value> to;

  git_diff_delta *
  head_to_index =
    ObjectWrap::Unwrap<GitStatusEntry>(args.This())->GetValue()->head_to_index;
// start convert_to_v8 block

  if (head_to_index != NULL) {
    // GitDiffDelta head_to_index
    to = GitDiffDelta::New((void *)head_to_index, false);
  } else {
    to = NanNull();
  }

// end convert_to_v8 block
  NanReturnValue(to);
}
NAN_METHOD(GitStatusEntry::IndexToWorkdir)
{
  NanScope();
  Handle<v8::Value> to;

  git_diff_delta *
  index_to_workdir =
    ObjectWrap::Unwrap<GitStatusEntry>(args.This())->GetValue()->index_to_workdir;
// start convert_to_v8 block

  if (index_to_workdir != NULL) {
    // GitDiffDelta index_to_workdir
    to = GitDiffDelta::New((void *)index_to_workdir, false);
  } else {
    to = NanNull();
  }

// end convert_to_v8 block
  NanReturnValue(to);
}
Persistent<Function> GitStatusEntry::constructor_template;
